; ##############################################################################
; ##############################################################################
; ##############################################################################
FAT_INITIALISIEREN:
	rcall ANZEIGE_FAT_INITIALISIERUNG	

	rcall FAT_BOOTSEKTOR_EINLESEN

	rcall FAT_VOLUME_BOOT_SEKTOR_EINLESEN

	rcall wait_100ms
	rcall LCD_SPACE
	rcall LCD_TEXT_OK

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	OUT:	(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L)								
;			(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H)								
;																				
FAT_BOOTSEKTOR_EINLESEN:
	; SEKTOR 0								
	STS(adr_SD_PHYS_SEKTOR_BYTE1),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE2),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE3),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE4),NULL
	; SEKTOR einlesen und im SRAM ablegen	
	rcall SD_CMD17			

	; Anzahl reservierte Sektoren (BOOT) herausfiltern		
	LDS temp1,(adr_SD_DATEN+0x1C6)
	LDS temp2,(adr_SD_DATEN+0x1C7)
	STS(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L),temp1
	STS(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H),temp2
	; FEHLERPRFUNG							
	LDS temp,(adr_SD_DATEN+0x1FE)
	; vergleich	x55							
	cpi temp,0x55
	brne FAT_BOOTSEKTOR_EINLESEN_FEHLER
	; FEHLERPRFUNG							
	LDS temp,(adr_SD_DATEN+0x1FF)
	; vergleich	xAA							
	cpi temp,0xAA
	brne FAT_BOOTSEKTOR_EINLESEN_FEHLER

	; LCD			
	ldi temp, 'B'
	rcall LCD_DATA
	rcall wait_100ms
	ret
;-------------------------------------------------------------------------------
FAT_BOOTSEKTOR_EINLESEN_FEHLER:
	; LED			
	cbi PORTD,LED_D_ROT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	INP:	(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L)								
;			(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H)								
;																				
;	OUT:	(adr_FAT_BYTES_PRO_SEKTOR_L)										
;			(adr_FAT_BYTES_PRO_SEKTOR_H)										
;																				
;			(adr_FAT_SEKTOREN_PRO_CLUSTER)										
;																				
;			(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_L)								
;			(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_H)								
;																				
;			(adr_FAT_SEKTOREN_PRO_FAT_L)										
;			(adr_FAT_SEKTOREN_PRO_FAT_H)										
;																				
;			(adr_FAT_START_SEKTOR_FAT_1_L)										
;			(adr_FAT_START_SEKTOR_FAT_1_H)										
;																				
;			(adr_FAT_START_SEKTOR_FAT_2_L)										
;			(adr_FAT_START_SEKTOR_FAT_2_H)										
;																				
;			(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_L)								
;			(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_H)								
;																				
;			(adr_FAT_START_SEKTOR_DATENBEREICH_L)								
;			(adr_FAT_START_SEKTOR_DATENBEREICH_H)								
;																				
;																				
FAT_VOLUME_BOOT_SEKTOR_EINLESEN:
	; SEKTOR								
	LDS temp1,(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L)
	LDS temp2,(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H)
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE4),NULL
	; SEKTOR einlesen und im SRAM ablegen	
	rcall SD_CMD17			
	; ANZAHL BYTES pro SEKTOR herausfiltern	
	LDS temp1,(adr_SD_DATEN+0x0B)
	LDS temp2,(adr_SD_DATEN+0x0C)
	STS(adr_FAT_BYTES_PRO_SEKTOR_L),temp1
	STS(adr_FAT_BYTES_PRO_SEKTOR_H),temp2
	; ANZAHL SEKTOREN pro CLUSTER herausfiltern	
	LDS temp1,(adr_SD_DATEN+0xD)
	STS(adr_FAT_SEKTOREN_PRO_CLUSTER),temp1
	; Anzahl reservierte Sektoren (VOLUME-BOOT) herausfiltern
	LDS temp1,(adr_SD_DATEN+0x0E)
	LDS temp2,(adr_SD_DATEN+0x0F)
	STS(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_L),temp1
	STS(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_H),temp2
	; Anzahl FAT KOPIEN herausfiltern		
	LDS temp1,(adr_SD_DATEN+0x10)
	STS(adr_FAT_KOPIEN),temp1
	; ANZAHL SEKTOREN pro FAT herausfiltern 
	LDS temp1,(adr_SD_DATEN+0x16)
	LDS temp2,(adr_SD_DATEN+0x17)	
	STS(adr_FAT_SEKTOREN_PRO_FAT_L),temp1
	STS(adr_FAT_SEKTOREN_PRO_FAT_H),temp2
;-------------------------------------------------------------------------------
	; BERECHNUNG STARTSEKTOR FAT1 	
	LDS temp1,(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L)
	LDS temp2,(adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H)
	LDS temp3,(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_L)
	LDS temp4,(adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_H)
	add temp1,temp3
	adc temp2,temp4
	STS(adr_FAT_START_SEKTOR_FAT_1_L),temp1
	STS(adr_FAT_START_SEKTOR_FAT_1_H),temp2
	; BERECHNUNG STARTSEKTOR FAT2 	
	LDS temp1,(adr_FAT_START_SEKTOR_FAT_1_L)
	LDS temp2,(adr_FAT_START_SEKTOR_FAT_1_H)
	LDS temp3,(adr_FAT_SEKTOREN_PRO_FAT_L)
	LDS temp4,(adr_FAT_SEKTOREN_PRO_FAT_H)
	; Schleife	
	LDS temp,(adr_FAT_KOPIEN)
	; kleiner 2 ?
	cpi temp,2
	brlo FAT_VOLUME_BOOT_SEKTOR_EINLESEN_F2S
	dec temp
FAT_VOLUME_BOOT_SEKTOR_EINLESEN_F2:
	add temp1,temp3
	adc temp2,temp4
	dec temp
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_F2
	; speichern	
FAT_VOLUME_BOOT_SEKTOR_EINLESEN_F2S:
	STS(adr_FAT_START_SEKTOR_FAT_2_L),temp1
	STS(adr_FAT_START_SEKTOR_FAT_2_H),temp2
	; BERECHNUNG STARTSEKTOR ROOT DIREKTORY	
	LDS temp1,(adr_FAT_START_SEKTOR_FAT_2_L)
	LDS temp2,(adr_FAT_START_SEKTOR_FAT_2_H)
	LDS temp3,(adr_FAT_SEKTOREN_PRO_FAT_L)
	LDS temp4,(adr_FAT_SEKTOREN_PRO_FAT_H)
	add temp1,temp3
	adc temp2,temp4
	STS(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_L),temp1
	STS(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_H),temp2
	; BERECHNUNG STARTSEKTOR DATENBEREICH	
	LDS temp1,(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_L)
	LDS temp2,(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_H)
	; + 32 Sektoren
	ldi temp3, low(32)
	ldi temp4,HIGH(32)
	add temp1,temp3
	adc temp2,temp4
	STS(adr_FAT_START_SEKTOR_DATENBEREICH_L),temp1
	STS(adr_FAT_START_SEKTOR_DATENBEREICH_H),temp2
	
;-------------------------------------------------------------------------------
	; FEHLERPRFUNG	vergleich "F"	
	LDS temp,(adr_SD_DATEN+0x36)
	cpi temp,'F'
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER
	; FEHLERPRFUNG	vergleich "A"	
	LDS temp,(adr_SD_DATEN+0x37)
	cpi temp,'A'
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER
	; FEHLERPRFUNG	vergleich "T"	
	LDS temp,(adr_SD_DATEN+0x38)
	cpi temp,'T'
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER
	; FEHLERPRFUNG	vergleich x55	
	LDS temp,(adr_SD_DATEN+0x1FE)
	cpi temp,0x55
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER
	; FEHLERPRFUNG	vergleich xAA	
	LDS temp,(adr_SD_DATEN+0x1FF)
	cpi temp,0xAA
	brne FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER

	; LCD			
	ldi temp, 'V'
	rcall LCD_DATA
	rcall wait_100ms
ret
;-------------------------------------------------------------------------------
FAT_VOLUME_BOOT_SEKTOR_EINLESEN_FEHLER:
	; LED			
	cbi PORTD,LED_D_ROT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP: 	  (adr_FAT_DIREKTORY_DATENSATZ_NR_L)									
;		  (adr_FAT_DIREKTORY_DATENSATZ_NR_H)									
;																				
; OUT:		(adr_DATEI_CLUSTER_L)												
;			(adr_DATEI_CLUSTER_H)												
;																				
;			(adr_DATEI_GROESSE_BYTE1)											
;			(adr_DATEI_GROESSE_BYTE2)											
;			(adr_DATEI_GROESSE_BYTE3)											
;			(adr_DATEI_GROESSE_BYTE4)											
;																				
FAT_ROOT_DIRECTORY_EINLESEN:
	; DATENSATZ-NR laden	
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_NR_L)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_NR_H)
	; durch 16				
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	; START_SEKTOR_ROOT_DIRECTORY laden	
	LDS temp3,(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_L)
	LDS temp4,(adr_FAT_START_SEKTOR_ROOT_DIRECTORY_H)
	; addieren							
	add temp1,temp3
	adc temp2,temp4
	clr temp3
	clr temp4
	; speichern					
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp3
	STS(adr_SD_PHYS_SEKTOR_BYTE4),temp4
	; SEKTOR einlesen			
	rcall SD_CMD17	
	; Z-initialisieren			
	ldi ZL, low(adr_FAT_DIREKTORY_DATENSATZ_32)
	ldi ZH,high(adr_FAT_DIREKTORY_DATENSATZ_32)
	; Y-initialisieren			
	ldi YL, low(adr_SD_DATEN)
	ldi YH,high(adr_SD_DATEN)
	; DATENSATZ-NR laden 		
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_NR_L)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_NR_H)
	; BITMUSTER					
	andi temp1,0b00001111
	andi temp2,0b00000000
	; mal 32					
	LSL temp1
	ROL temp2
	LSL temp1
	ROL temp2
	LSL temp1
	ROL temp2
	LSL temp1
	ROL temp2
	LSL temp1
	ROL temp2
	; Y-berechnen				
	add YL,temp1
	adc YH,temp2
	; SCHLEIFE					
	ldi temp,32
FAT_ROOT_DIRECTORY_EINLESEN_S:
	LD temp1,Y+	; laden 	Y+1	
	ST Z+,temp1	; speichern Z+1	
	dec temp
	brne FAT_ROOT_DIRECTORY_EINLESEN_S
;-------------------------------------------------------------------------------
	; AUSWERTUNG START CLUSTER		
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_32+26)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_32+27)
	; SPEICHERN						
	STS(adr_DATEI_CLUSTER_L),temp1
	STS(adr_DATEI_CLUSTER_H),temp2
	; AUSWERTUNG DATEIGRSSE		
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_32+28)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_32+29)
	LDS temp3,(adr_FAT_DIREKTORY_DATENSATZ_32+30)
	LDS temp4,(adr_FAT_DIREKTORY_DATENSATZ_32+31)
	; SPEICHERN						
	STS(adr_DATEI_GROESSE_BYTE1),temp1
	STS(adr_DATEI_GROESSE_BYTE2),temp2
	STS(adr_DATEI_GROESSE_BYTE3),temp3
	STS(adr_DATEI_GROESSE_BYTE4),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP:	(adr_DATEI_CLUSTER_L)													
;		(adr_DATEI_CLUSTER_H)													
; 		gltige WERTE sind 2 bis ...											
;																				
; OUT:	(adr_SD_PHYS_SEKTOR_BYTE1)												
;		(adr_SD_PHYS_SEKTOR_BYTE2)												
;		(adr_SD_PHYS_SEKTOR_BYTE3)												
;		(adr_SD_PHYS_SEKTOR_BYTE4)												
;																				
;																				
FAT_BERECHNUNG_CLUSTER_NR_IN_PHYSISCHER_SEKTOR_NR:
	; CLEAR			
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	; CLUSTER NUMMER					
	LDS ZL,(adr_DATEI_CLUSTER_L)
	LDS ZH,(adr_DATEI_CLUSTER_H)
	; CLUSTER NUMMER aufbereiten (-2)	
	sbiw ZL,2
	; NULL-PRFUNG						
	tst ZL
	brne FAT_BERECHNUNG_CLUSTER_NR_w
	tst ZH
	brne FAT_BERECHNUNG_CLUSTER_NR_w
	rjmp FAT_BERECHNUNG_CLUSTER_NR_ww
	; SCHLEIFE (SEKTOREN pro CLUSTER mal CLUSTER NUMMER)
FAT_BERECHNUNG_CLUSTER_NR_w:
	; SEKTOREN pro CLUSTER	
	LDS temp5,(adr_FAT_SEKTOREN_PRO_CLUSTER)		
FAT_BERECHNUNG_CLUSTER_NR_s:
	add temp1,temp5
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	sbiw ZL,1
	tst ZL
	brne FAT_BERECHNUNG_CLUSTER_NR_s
	tst ZH
	brne FAT_BERECHNUNG_CLUSTER_NR_s

FAT_BERECHNUNG_CLUSTER_NR_ww:
	; START SEKTOR DATENBEREICH	
	LDS temp5,(adr_FAT_START_SEKTOR_DATENBEREICH_L)
	LDS temp6,(adr_FAT_START_SEKTOR_DATENBEREICH_H)
	clr temp7
	clr temp8
	; addieren					
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; speichern	PHYSISCHER SEKTOR
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp3
	STS(adr_SD_PHYS_SEKTOR_BYTE4),temp4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP:	(adr_DATEI_CLUSTER_L)													
;		(adr_DATEI_CLUSTER_H)													
;																				
; OUT: 	(adr_DATEI_CLUSTER_FAT_INHALT_BYTE1)									
; 	 	(adr_DATEI_CLUSTER_FAT_INHALT_BYTE2)									
;																				
FAT_TABELLE_EINTRAEGE_AUSLESEN:
	; CLUSTER NUMMER					
	LDS temp1,(adr_DATEI_CLUSTER_L)
	LDS temp2,(adr_DATEI_CLUSTER_H)
	clr temp3
	clr temp4
	; SEKTOR errechnen					
	; durch 256							
	mov temp1,temp2
	clr temp2
	; START-SEKTOR FAT 1				
	LDS temp5,(adr_FAT_START_SEKTOR_FAT_1_L)
	LDS temp6,(adr_FAT_START_SEKTOR_FAT_1_H)
	clr temp7
	clr temp8
	; ADDIEREN						
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; speichern	PHYSISCHE ADRESSE	
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp3
	STS(adr_SD_PHYS_SEKTOR_BYTE4),temp4
	; SEKTOR einlesen			
	rcall SD_CMD17
	; POSITION des EINTRAGEs bestimmen
	LDS temp1,(adr_DATEI_CLUSTER_L)
	LDS temp2,(adr_DATEI_CLUSTER_H)
	clr temp2
	; mal 2						
	LSL temp1
	ROL temp2
	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_SD_DATEN)
	ldi ZH,HIGH(adr_SD_DATEN)
	; addieren					
	add ZL,temp1
	adc ZH,temp2	
	; einlesen und speichern	
	LD temp1,Z+
	LD temp2,Z+
	STS(adr_DATEI_CLUSTER_FAT_INHALT_BYTE1),temp1
	STS(adr_DATEI_CLUSTER_FAT_INHALT_BYTE2),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################