

;												
; SD-KARTE und ATmega8							
; Bernhard.Erfurt@gmx.de						
; 01/2008										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> SD-KARTE (CS)							
; PB3 ==> SD-KARTE								
; PB4 ==> SD-KARTE								
; PB5 ==> SD-KARTE								
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> LCD									
; PC1 ==> LCD									
; PC2 ==> LCD									
; PC3 ==> LCD									
; PC4 ==> LCD									
; PC5 ==> LCD									
;												
; PD0 ==> RX									
; PD1 ==> TX									
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; USART											
.equ BAUD		=57600
; TIMER-WERTE									
.equ TIMERWERT1	=65536-15625		;(2 hoch 16 minus....15625) bei 16MHz + Vorteiler 1024 => 1s 	
; SPI											
.equ SPI_B_CS	= 2
.equ SPI_B_MOSI	= 3
.equ SPI_B_MISO	= 4
.equ SPI_B_SCK	= 5


; LEDS 											
.equ LED_D_GRUEN		= 5
.equ LED_D_GELB			= 6
.equ LED_D_ROT			= 7
; LCD								
.equ LCD_PORT				= PORTC
.equ LCD_D0					= 0
.equ LCD_D1					= 1
.equ LCD_D2					= 2
.equ LCD_D3					= 3
.equ LCD_RS					= 4
.equ LCD_E					= 5

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_ss						=0x0060+10			; ZEIT
.equ adr_mm						=0x0060+11
.equ adr_hh						=0x0060+12
.equ adr_TAG					=0x0060+13
.equ adr_MONAT					=0x0060+14
.equ adr_JAHR					=0x0060+15

.equ adr_SD_CSD_BYTE_01			= 0x0060+50			; CMD9	
.equ adr_SD_CSD_BYTE_02			= 0x0060+51
.equ adr_SD_CSD_BYTE_03			= 0x0060+52
.equ adr_SD_CSD_BYTE_04			= 0x0060+53
.equ adr_SD_CSD_BYTE_05			= 0x0060+54
.equ adr_SD_CSD_BYTE_06			= 0x0060+55
.equ adr_SD_CSD_BYTE_07			= 0x0060+56
.equ adr_SD_CSD_BYTE_08			= 0x0060+57
.equ adr_SD_CSD_BYTE_09			= 0x0060+58
.equ adr_SD_CSD_BYTE_10			= 0x0060+59
.equ adr_SD_CSD_BYTE_11			= 0x0060+60
.equ adr_SD_CSD_BYTE_12			= 0x0060+61
.equ adr_SD_CSD_BYTE_13			= 0x0060+62
.equ adr_SD_CSD_BYTE_14			= 0x0060+63
.equ adr_SD_CSD_BYTE_15			= 0x0060+64
.equ adr_SD_CSD_BYTE_16			= 0x0060+65

.equ adr_SD_CID_BYTE_01			= 0x0060+70			; CMD10
.equ adr_SD_CID_BYTE_02			= 0x0060+71
.equ adr_SD_CID_BYTE_03			= 0x0060+72
.equ adr_SD_CID_BYTE_04			= 0x0060+73
.equ adr_SD_CID_BYTE_05			= 0x0060+74
.equ adr_SD_CID_BYTE_06			= 0x0060+75
.equ adr_SD_CID_BYTE_07			= 0x0060+76
.equ adr_SD_CID_BYTE_08			= 0x0060+77
.equ adr_SD_CID_BYTE_09			= 0x0060+78
.equ adr_SD_CID_BYTE_10			= 0x0060+79
.equ adr_SD_CID_BYTE_11			= 0x0060+80
.equ adr_SD_CID_BYTE_12			= 0x0060+81
.equ adr_SD_CID_BYTE_13			= 0x0060+82
.equ adr_SD_CID_BYTE_14			= 0x0060+83
.equ adr_SD_CID_BYTE_15			= 0x0060+84
.equ adr_SD_CID_BYTE_16			= 0x0060+85

.equ adr_SD_READ_BLOCK_LEN		= 0x0060+90	 		; aus CMD 9
.equ adr_SD_C_SITZE_L			= 0x0060+91
.equ adr_SD_C_SITZE_H			= 0x0060+92
.equ adr_SD_C_SITZE_MULT		= 0x0060+93

.equ adr_SD_AUF_READ_BLOCK_LEN_L= 0x0060+95			; AUFBEREITETER WERT 
.equ adr_SD_AUF_READ_BLOCK_LEN_H= 0x0060+96			

.equ adr_SD_AUF_C_SITZE_MULT_L	= 0x0060+97			; AUFBEREITETER WERT 
.equ adr_SD_AUF_C_SITZE_MULT_H	= 0x0060+98

.equ adr_SD_PHYS_SITZE_B1		= 0x0060+100		; ANZAHL der Physikalischen SEKTOREN	
.equ adr_SD_PHYS_SITZE_B2		= 0x0060+101
.equ adr_SD_PHYS_SITZE_B3		= 0x0060+102
.equ adr_SD_PHYS_SITZE_B4		= 0x0060+103


.equ adr_SD_PHYS_SEKTOR_BYTE1	= 0x0060+140				; Physische Adresse eines Sektors (Bootsektor=0)
.equ adr_SD_PHYS_SEKTOR_BYTE2	= 0x0060+141
.equ adr_SD_PHYS_SEKTOR_BYTE3	= 0x0060+142
.equ adr_SD_PHYS_SEKTOR_BYTE4	= 0x0060+143

.equ adr_FAT_RESERVIERTE_SEKTOREN_BOOT_L	=0x0060+150		;  Anzahl reservierter Sektoren (Boot Sektor)
.equ adr_FAT_RESERVIERTE_SEKTOREN_BOOT_H	=0x0060+151

.equ adr_FAT_BYTES_PRO_SEKTOR_L				= 0x0060+152 	; Bytes pro Sektor		
.equ adr_FAT_BYTES_PRO_SEKTOR_H				= 0x0060+153 

.equ adr_FAT_SEKTOREN_PRO_CLUSTER			= 0x0060+154 	; Sektoren pro Cluster	

.equ adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_L	=0x0060+155 	; Anzahl reservierter Sektoren (Volume Boot Sektor)
.equ adr_FAT_RESERVIERTE_SEKTOREN_VOLUME_H	=0x0060+156

.equ adr_FAT_KOPIEN							=0x0060+157 	; Anzahl FAT Kopien	

.equ adr_FAT_SEKTOREN_PRO_FAT_L				=0x0060+158 	; Anzahl FAT Kopien	
.equ adr_FAT_SEKTOREN_PRO_FAT_H				=0x0060+159

.equ adr_FAT_START_SEKTOR_FAT_1_L			= 0x0060+160	; START SEKTOR FAT1
.equ adr_FAT_START_SEKTOR_FAT_1_H			= 0x0060+161

.equ adr_FAT_START_SEKTOR_FAT_2_L			= 0x0060+162	; START SEKTOR FAT2
.equ adr_FAT_START_SEKTOR_FAT_2_H			= 0x0060+163

.equ adr_FAT_START_SEKTOR_ROOT_DIRECTORY_L	= 0x0060+164	; START SEKTOR ROOT-DIRECTORY	
.equ adr_FAT_START_SEKTOR_ROOT_DIRECTORY_H	= 0x0060+165

.equ adr_FAT_START_SEKTOR_DATENBEREICH_L	= 0x0060+166	; START SEKTOR DATENBEREICH		
.equ adr_FAT_START_SEKTOR_DATENBEREICH_H	= 0x0060+167

.equ adr_FAT_DIREKTORY_DATENSATZ_NR_L		= 0x0060+200	; DATENSATZ-NUMMER fr ROOT DIRECTORY
.equ adr_FAT_DIREKTORY_DATENSATZ_NR_H		= 0x0060+201

.equ adr_FAT_DIREKTORY_DATENSATZ_32			= 0x0060+210	; 32 BYTE DATENSATZ aus ROOT DIRECTORY

.equ adr_DATEI_CLUSTER_L					= 0x0060+250	; CLUSTER 		
.equ adr_DATEI_CLUSTER_H					= 0x0060+251

.equ adr_DATEI_CLUSTER_FAT_INHALT_BYTE1		= 0x0060+252	; CLUSTER EINTRAG in FAT	
.equ adr_DATEI_CLUSTER_FAT_INHALT_BYTE2		= 0x0060+253

.equ adr_DATEI_SEKTOR_ZAEHLER				= 0x0060+262	; HILFSZHLER	

.equ adr_DATEI_GROESSE_BYTE1				= 0x0060+300	; DATEI-Gre lt. Directory	
.equ adr_DATEI_GROESSE_BYTE2				= 0x0060+301
.equ adr_DATEI_GROESSE_BYTE3				= 0x0060+302
.equ adr_DATEI_GROESSE_BYTE4				= 0x0060+303

.equ adr_DATEI_GROESSE_IST_BYTE1			= 0x0060+304	; DATEI-Gre ZHLER		
.equ adr_DATEI_GROESSE_IST_BYTE2			= 0x0060+305
.equ adr_DATEI_GROESSE_IST_BYTE3			= 0x0060+306
.equ adr_DATEI_GROESSE_IST_BYTE4			= 0x0060+307

.equ adr_SD_DATEN							= 0x0060+400	; DATEMBYTES				

; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_DATEN			= 0

; REGISTER										

.def FEHLER_CODE= R8

.def NULL 		= R10
.def EINS	 	= R11
.def VOLL   	= R12

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       						
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	; LED		
	cbi PORTD,LED_D_ROT
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; SRAM_CLEAR										
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00101110	; SPI	
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b11111111	; LCD	
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111	; LEDs	
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				


			


; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; 255				
	ldi temp,255
	mov VOLL,temp
	; FEHLER_CODE
	clr FEHLER_CODE
	; ZEIT NULL			
	STS(adr_hh),NULL
	STS(adr_mm),NULL
	STS(adr_ss),NULL

; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; USART_INITIALISIEREN								
	rcall USART_INITIALISIEREN
; SPI_INITIALISIERUNG								
	rcall SPI_INITIALISIERUNG
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; LED-TEST											
	rcall LED_TEST

; Interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################

; SD_KARTE_INITIALISIERUNG			
	rcall SD_KARTE_INITIALISIERUNG	
	rcall wait_100ms
; ANZEIGE_SD_PHYSISCH_INFO					
	rcall ANZEIGE_SD_PHYSISCH_INFO
	rcall wait_1s
	rcall wait_1s
; FAT_INITIALISIEREN				
	rcall FAT_INITIALISIEREN
	rcall wait_1s	
	rcall ANZEIGE_FAT_INFO
	rcall wait_1s
	rcall ANZEIGE_FAT1_INHALT
	rcall wait_1s
	rcall wait_1s
; DIRECTORY_EINLESEN_ANZEIGEN			
	rcall DIRECTORY_EINLESEN_ANZEIGEN
; DIRECTORY_DATEI_SUCHEN				
	rcall DIRECTORY_DATEI_SUCHEN
; DIRECTORY_DATEI_READ					
	rcall DIRECTORY_DATEI_READ
; PHYSISCHE_SEKTOREN_1000_EINLESEN	
 	rcall PHYSISCHE_SEKTOREN_1000_EINLESEN


; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	

	cbi PORTD,LED_D_GRUEN	; GRN	



	rcall PROGRAMM_CHECK


rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
PHYSISCHE_SEKTOREN_1000_EINLESEN:
	; ZEIT NULL			
	STS(adr_hh),NULL
	STS(adr_mm),NULL
	STS(adr_ss),NULL

	; START-SEKTOR				
	STS(adr_SD_PHYS_SEKTOR_BYTE1),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE2),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE3),NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE4),NULL

	; Y-Schleife initialisieren	
	ldi YL,  LOW(1000)
	ldi YH, HIGH(1000)	
PHYSISCHE_SEKTOREN_1000_EINLESEN_w:
	; SEKTOR einlesen			
	rcall SD_CMD17			
	; ANZEIGE					
	rcall ANZEIGE_SD_BLOCK_NR	
	; USART 512 BYTES			
	rcall SD_512_BYTES_USART	
	; SEKTOR +1					
	LDS temp1,(adr_SD_PHYS_SEKTOR_BYTE1)
	LDS temp2,(adr_SD_PHYS_SEKTOR_BYTE2)
	LDS temp3,(adr_SD_PHYS_SEKTOR_BYTE3)
	LDS temp4,(adr_SD_PHYS_SEKTOR_BYTE4)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp3
	STS(adr_SD_PHYS_SEKTOR_BYTE4),temp4
	; SCHLEIFE Y-1	
	sbiw YL,1 
	tst YH
	brne PHYSISCHE_SEKTOREN_1000_EINLESEN_w
	tst YL
	brne PHYSISCHE_SEKTOREN_1000_EINLESEN_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; die ersten DIREKTORY EINTRGE anzeigen										
DIRECTORY_EINLESEN_ANZEIGEN:
	; NULL	
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_L),NULL
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_H),NULL
DIRECTORY_EINLESEN_ANZEIGEN_w:
	; DATENSATZ laden	
	rcall FAT_ROOT_DIRECTORY_EINLESEN ; INP: SRAM
	; ANZEIGEN			
	rcall ANZEIGE_ROOT_DIRECTORY_1_DATENSATZ
	; ZHLER			
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_NR_L)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_NR_H)	
	add temp1,EINS
	adc temp2,NULL
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_L),temp1
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_H),temp2
	; PAUSE		
	rcall wait_1s
	; SCHLEIFE	
	cpi temp2,high(10+1)
	brne DIRECTORY_EINLESEN_ANZEIGEN_w
	cpi temp1, low(10+1)
	brne DIRECTORY_EINLESEN_ANZEIGEN_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; OUT:	(adr_DATEI_CLUSTER_L)													
;		(adr_DATEI_CLUSTER_H)													
;																				
DIRECTORY_DATEI_SUCHEN:
	; FEHLERCODE	
	clr FEHLER_CODE
	; NULL			
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_L),NULL
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_H),NULL
DIRECTORY_DATEI_SUCHEN_w:
	; DATENSATZ laden	
	rcall FAT_ROOT_DIRECTORY_EINLESEN ; INP: SRAM
	; ANZEIGEN			
	rcall ANZEIGE_ROOT_DIRECTORY_1_DATENSATZ
	; vergleich	"D"
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+0)
	cpi temp,'D'
	brne DIRECTORY_DATEI_SUCHEN_ww
	; vergleich	"A"
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+1)
	cpi temp,'A'
	brne DIRECTORY_DATEI_SUCHEN_ww
	; vergleich	"T"
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+2)
	cpi temp,'T'
	brne DIRECTORY_DATEI_SUCHEN_ww
	; vergleich	"E"
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+3)
	cpi temp,'E'
	brne DIRECTORY_DATEI_SUCHEN_ww
	; vergleich	"N"
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+4)
	cpi temp,'N'
	brne DIRECTORY_DATEI_SUCHEN_ww
	; vergleich	" "
	LDS temp,(adr_FAT_DIREKTORY_DATENSATZ_32+5)
	cpi temp,' '
	brne DIRECTORY_DATEI_SUCHEN_ww

	rjmp DIRECTORY_DATEI_SUCHEN_GEFUNDEN
DIRECTORY_DATEI_SUCHEN_ww:
	; ZHLER			
	LDS temp1,(adr_FAT_DIREKTORY_DATENSATZ_NR_L)
	LDS temp2,(adr_FAT_DIREKTORY_DATENSATZ_NR_H)	
	add temp1,EINS
	adc temp2,NULL
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_L),temp1
	STS (adr_FAT_DIREKTORY_DATENSATZ_NR_H),temp2
	; SCHLEIFE			
	cpi temp2,high(512+1)
	brne DIRECTORY_DATEI_SUCHEN_w
	cpi temp1, low(512+1)
	brne DIRECTORY_DATEI_SUCHEN_w
	; FEHLER_CODE		
	ldi temp,100
	mov FEHLER_CODE,temp
	; ANZEIGE ERROR		
	rcall ANZEIGE_ERROR	
	rcall wait_1s
	rcall wait_1s
	ret
DIRECTORY_DATEI_SUCHEN_GEFUNDEN:
	clr FEHLER_CODE
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP:	(adr_DATEI_CLUSTER_L)													
;		(adr_DATEI_CLUSTER_H)													
;																				
;		(adr_DATEI_GROESSE_BYTE1)												
;		(adr_DATEI_GROESSE_BYTE2)												
;		(adr_DATEI_GROESSE_BYTE3)												
;		(adr_DATEI_GROESSE_BYTE4)												
;																				
; OUT:   DATEN																	
;																				
DIRECTORY_DATEI_READ:
	; FEHLERCODE	
	tst FEHLER_CODE
	breq DIRECTORY_DATEI_READ_START
	ret
;-------------------------------------------------------------------------------
DIRECTORY_DATEI_READ_START:
	; SEKTOREN pro CLUSTER							
	LDS temp,(adr_FAT_SEKTOREN_PRO_CLUSTER)
	; SEKTOR_ZAEHLER initialisieren					
	STS(adr_DATEI_SEKTOR_ZAEHLER),temp
	; BERECHNUNG_CLUSTER_NR_IN_PHYSISCHER_SEKTOR NR
	rcall FAT_BERECHNUNG_CLUSTER_NR_IN_PHYSISCHER_SEKTOR_NR
;-------------------------------------------------------------------------------
; CLUSTER komplett einlesen														
DIRECTORY_DATEI_READ_CLUSTER_KOMPLETT:
	; SEKTOR einlesen			
	rcall SD_CMD17
	; DATEN AUSGABE				
	rcall DIRECTORY_DATEI_READ_AUSGABE	
	; ANZEIGE			
	rcall DIRECTORY_DATEI_READ_AUSGABE_ANZEIGE
	; SEKTOR +1					
	LDS temp1,(adr_SD_PHYS_SEKTOR_BYTE1)
	LDS temp2,(adr_SD_PHYS_SEKTOR_BYTE2)
	LDS temp3,(adr_SD_PHYS_SEKTOR_BYTE3)
	LDS temp4,(adr_SD_PHYS_SEKTOR_BYTE4)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp1
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp2
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp3
	STS(adr_SD_PHYS_SEKTOR_BYTE4),temp4
	; SEKTOR_ZAEHLER			
	LDS temp,(adr_DATEI_SEKTOR_ZAEHLER)		
	dec temp
	STS(adr_DATEI_SEKTOR_ZAEHLER),temp		
	brne DIRECTORY_DATEI_READ_CLUSTER_KOMPLETT
;-------------------------------------------------------------------------------
	; FAT_TABELLE_EINTRAEGE_AUSLESEN
	rcall FAT_TABELLE_EINTRAEGE_AUSLESEN
	; AUSWERTUNG			
	LDS temp1,(adr_DATEI_CLUSTER_FAT_INHALT_BYTE1)
	LDS temp2,(adr_DATEI_CLUSTER_FAT_INHALT_BYTE2)
	; xFF xFF suchen	
	cpi temp1,0xFF
	brne DIRECTORY_DATEI_READ_NAECHSTER_CLUSTER
	cpi temp2,0xFF
	brne DIRECTORY_DATEI_READ_NAECHSTER_CLUSTER
	rjmp DIRECTORY_DATEI_READ_FERTIG
;-------------------------------------------------------------------------------
DIRECTORY_DATEI_READ_NAECHSTER_CLUSTER:
	LDS temp1,(adr_DATEI_CLUSTER_FAT_INHALT_BYTE1)
	LDS temp2,(adr_DATEI_CLUSTER_FAT_INHALT_BYTE2)
	STS(adr_DATEI_CLUSTER_L),temp1
	STS(adr_DATEI_CLUSTER_H),temp2
	rjmp DIRECTORY_DATEI_READ_START
;-------------------------------------------------------------------------------
DIRECTORY_DATEI_READ_FERTIG:
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
	ret
; ##############################################################################
DIRECTORY_DATEI_READ_AUSGABE:
	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_SD_DATEN)
	ldi ZH,HIGH(adr_SD_DATEN)
	; Y-Schleife initialisieren	
	ldi YL,  LOW(512)
	ldi YH, HIGH(512)
	; DATEIGRSSE				
	LDS temp5,(adr_DATEI_GROESSE_BYTE1)
	LDS temp6,(adr_DATEI_GROESSE_BYTE2)
	LDS temp7,(adr_DATEI_GROESSE_BYTE3)
	LDS temp8,(adr_DATEI_GROESSE_BYTE4)
DIRECTORY_DATEI_READ_AUSGABE_w:
	; DATEIGRSSE	
	LDS temp1,(adr_DATEI_GROESSE_IST_BYTE1)
	LDS temp2,(adr_DATEI_GROESSE_IST_BYTE2)
	LDS temp3,(adr_DATEI_GROESSE_IST_BYTE3)
	LDS temp4,(adr_DATEI_GROESSE_IST_BYTE4)

	; vergleich			
	cp temp4,temp8
	brne DIRECTORY_DATEI_READ_AUSGABE_ww
	cp temp3,temp7
	brne DIRECTORY_DATEI_READ_AUSGABE_ww
	cp temp2,temp6
	brne DIRECTORY_DATEI_READ_AUSGABE_ww
	cp temp1,temp5
	brne DIRECTORY_DATEI_READ_AUSGABE_ww
	rjmp DIRECTORY_DATEI_READ_AUSGABE_3w
DIRECTORY_DATEI_READ_AUSGABE_ww:
	; LADEN und Z+1		
	LD temp,Z+
	; DATENBYTES senden			
	rcall SENDEN	; INP: TEMP	
	; +1				
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	; speichern			
	STS(adr_DATEI_GROESSE_IST_BYTE1),temp1
	STS(adr_DATEI_GROESSE_IST_BYTE2),temp2
	STS(adr_DATEI_GROESSE_IST_BYTE3),temp3
	STS(adr_DATEI_GROESSE_IST_BYTE4),temp4
DIRECTORY_DATEI_READ_AUSGABE_3w:
	; Y-1				
	sbiw YL,1 
	tst YH
	brne DIRECTORY_DATEI_READ_AUSGABE_w
	tst YL
	brne DIRECTORY_DATEI_READ_AUSGABE_w

DIRECTORY_DATEI_READ_AUSGABE_FERTIG:
ret
;-------------------------------------------------------------------------------
DIRECTORY_DATEI_READ_AUSGABE_ANZEIGE:
	; ZEILE1	
	rcall LCD_CLEAR
	; DATEIGRSSE lt. Directory		
	LDS temp1,(adr_DATEI_GROESSE_BYTE1)
	LDS temp2,(adr_DATEI_GROESSE_BYTE2)
	LDS temp3,(adr_DATEI_GROESSE_BYTE3)
	LDS temp4,(adr_DATEI_GROESSE_BYTE4)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	rcall LCD_FORMAT
	rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
	; ZEILE2	
	rcall LCD_ZEILE2
	; DATEIGRSSE	
	LDS temp1,(adr_DATEI_GROESSE_IST_BYTE1)
	LDS temp2,(adr_DATEI_GROESSE_IST_BYTE2)
	LDS temp3,(adr_DATEI_GROESSE_IST_BYTE3)
	LDS temp4,(adr_DATEI_GROESSE_IST_BYTE4)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	rcall LCD_FORMAT
	rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ

	; ZEILE4	
	rcall LCD_ZEILE4
	; CLUSTER NUMMER	
	LDS temp1,(adr_DATEI_CLUSTER_L)
	LDS temp2,(adr_DATEI_CLUSTER_H)
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	rcall LCD_FORMAT
	rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SD_KARTE_LCD.asm"
.include "SD_KARTE_SONSTIGES.asm"
.include "SD_KARTE_SD.asm"
.include "SD_KARTE_SPI.asm"
.include "SD_KARTE_FAT.asm"
.include "SD_KARTE_TIMER.asm"
.include "SD_KARTE_FUNKTIONEN.asm"


; ##############################################################################
; ##############################################################################
; ##############################################################################


TEXT_BEGRUESSUNG_1:
.db "SD-KARTE",0

TEXT_BEGRUESSUNG_2:
.db "ATmega8",0

TEXT_BEGRUESSUNG_3:
.db "Version 2",0

TEXT_BEGRUESSUNG_4:
.db "12.Januar 2008",0

TEXT_INITIALISIERUNG:
.db "INITIALISIERUNG",0

TEXT_FAT_INITIALISIERUNG:
.db "FAT-INI...",0

TEXT_PHYSISCH:
.db "PHYSISCH",0

TEXT_SEKTOREN:
.db "SEKTOREN",0

TEXT_ERROR:
.db "ERROR",0